<template lang="html">
{@ html @}
</template>
<style lang="css"{% if scoped %} scoped{% endif %}>
{@ css @}
</style>
<script type="javascript">
    import axios from 'axios'
## for mixin in mixins
    import {@ mixin @} from "./{@ mixin @}.js"
## endfor
   
    export default {
        name: "{@ name @}",
        props: {@ props @},
        mixins: [{% for mixin in mixins %}{% if loop.index1 > 1 %}, {% endif %}{@ mixin @}{% endfor %}],
        data: function(){
            return {
                loaded:  false,
                last:    new Date,
                content: null
            }
        },
        beforeCreate: function(){
            this._urls = {
                data: "{@ url.data @}",
                action: "{@ url.call @}"
            }
        },
        created: function(){
            console.log("{@ name @} loading");
            this.loaded = false;
            this.last = new Date;
            this.reload();
        },
        methods: {
## for method in methods
            {@ method @}: function(args, callback){
                axios.post(this._urls.action, {
                    name: "{@ method @}",
                    args: args
                }).then(function(response){
                    callback(response.data);
                });
            },
## endfor
            sync: function(callback){
                console.log("{@ name @} syncing");
                
                axios.post(this._urls.data, {
                    props: this.$props,
                    content: this.content
                }).then(function(response){
                    callback(response.data);
                });
            },
            reload: function(){
                let self = this;
                self.loaded = false;
                this.sync(function(content){
                    self.content = content;
                    self.loaded = true;
                    self.last = new Date;
                    
                    console.log("{@ name @} synced");
                });
            }
        },
        watch: {
## for watcher in watchers
            {@ watcher @}: function(v, u){
                this.reload();
            }{% if not loop.is_last %},{% endif %}
## endfor
        }
    }
</script>
